

  '-------------------------------------------------------------------------------
  function GaussBlur(sys iwidth,iheight,passes, string* srcFile,targetFile) as sys
  '===============================================================================
  '
  type bgra byte b,g,r,a
  '
  sys    i,j,k,pass
  sys    iWidth1, iHeight1
  '
  sys    hFrameA, hFrameResult
  string hdBitsA, hdBitsB, hdBitsResult
  '
  sys gauss_width, gauss_width1, sumr, sumg, sumb
  '
  single igauss_sum
  sys gauss_sum, shifter
  sys r,g,b, IndexX,IndexY, a,c,d
  '
  #indexbase 0
  sys gauss_fact[24]
  '
  '
  'GAUSSIAN DISTRIBUTION
  '=====================

  'gauss_width = 5 : gauss_fact<= 1,4,6,4,1
  'gauss_width = 7 : gauss_fact<= 1,6,15,20,15,6,1
  gauss_width = 9 : gauss_fact<= 1,8,28,56,70,56,28,8,1
  '
  gauss_width1 = gauss_width - 1
  iWidth1  = iWidth -1
  iHeight1 = iHeight-1
  '
  '
  for i = 0 TO gauss_width1
    gauss_sum += gauss_fact(i)
  next
  '
  igauss_sum=1/gauss_sum
  '
  '
  shifter = gauss_width-1
  shr shifter, 1

  getImageFromFile srcFileA, hFrameA
  getImageWidth hFrameA, iWidth
  CreateThumbNailFromImage hFrameA, iWidth, iHeight, hFrameResult

  'BGRA

  ' ------
  passes=4
  '=======

  for pass = 1 TO passes

    for i = 0 to iWidth1
      for j = 0 to iHeight1

        sumr=0
        sumg=0
        sumb=0
        for k = 0 TO gauss_width1

          indexX = i - shifter + k
          indexY = j

          if indexX < 0 THEN
            indexX = -indexX
          elseif indexX > iWidth1 then
            indexX = iWidth1-(indexX-iWidth1)
          end if

          a= gauss_fact(k)
          getPixel pImage,indexx,indexy
          mov ecx,eax
          mov edx,a     'FACTOR
          '----------
          xor eax,eax
          mov al,cl
          mul dl
          add sumb,eax
          shr ecx,8 'NEXT COLOR BYTE
          '----------
          xor eax,eax
          mov al,cl
          mul dl
          add sumg,eax
          shr ecx,8 'NEXT COLOR BYTE
          '----------
          xor eax,eax
          mov al,cl
          mul dl
          add sumr,eax
          'shr ecx,8 'NEXT COLOR BYTE
          '----------

          'r = ImageArrayA(indexX, indexY).R
          'g = ImageArrayA(indexX, indexY).G
          'b = ImageArrayA(indexX, indexY).B

          'sumr += r * a
          'sumg += g * a
          'sumb += b * a

        next

        'AVOID DIVISION
        '
        'setpixel pimage,...
        '
        ImageArrayB(i, j).R = sumr*igauss_sum
        ImageArrayB(i, j).G = sumg*igauss_sum
        ImageArrayB(i, j).B = sumb*igauss_sum

      next 'height1
    next 'width1

    for i = 0 to iWidth1
      for j = 0 to iHeight1

        sumr=0
        sumg=0
        sumb=0

        for k = 0 to gauss_width1

          indexX = i
          indexY = j - shifter + k

          if indexY < 0 then
            indexY = -indexY
          elseif indexY > iHeight1 then
           indexY = iHeight1-(indexY-iHeight1)
          end if

          a= gauss_fact(k)
          getpixel pImage indexX, indexY
          mov ecx,eax
          mov edx,a     'FACTOR
          '----------
          xor eax,eax
          mov al,cl
          mul dl
          add sumb,eax
          shr ecx,8
          '----------
          xor eax,eax
          mov al,cl
          mul dl
          add sumg,eax
          shr ecx,8
          '----------
          xor eax,eax
          mov al,cl
          mul dl
          add sumr,eax
          shr ecx,8
          '----------

          'r = ImageArrayB(indexX, indexY).R
          'g = ImageArrayB(indexX, indexY).G
          'b = ImageArrayB(indexX, indexY).B

          'sumr += r * a
          'sumg += g * a
          'sumb += b * a

        next
        psetpixel pthumbnail...
        ImageArrayResult(i, j).R = sumr * igauss_sum
        ImageArrayResult(i, j).G = sumg * igauss_sum
        ImageArrayResult(i, j).B = sumb * igauss_sum

      next
    next

    if pass <> passes then
      hdBitsA = hdBitsResult
    end if

  next

  SaveImageToFile TargetFile,pBitMap



end function
