'-----------------------------------------


    dim shared as long FREEIMAGE
    dim shared as long GLSL
    dim shared as long hstatus

    dim shared as proc glCreateShader,glShaderSource,glCompileShader 'glGetObjectParameteriv
    dim shared as proc glGetShaderiv,glGetInfoLog,glAttachShader,glDetachShader,glDeleteShader,glLinkProgram
    dim shared as proc glCreateProgram,glDeleteProgram,glGetProgramiv,glUseProgram
    dim shared as proc glGetUniformLocation,glGetUniformfv,glGetUniformiv
    dim shared as proc glUniform1f,glUniform2f,glUniform3f,glUniform4f
    dim shared  as proc glActiveTexture,glMultiTexCoord2f,glMultiTexCoord2fv

sub gAddress(byval zs as zstring ptr, byref p as proc)
    p=wglGetProcAddress(zS)
    if p=0 then GLSL=0
end sub


sub BindGLSL()
    dim a as long
    GLSL=-1
    ' Multitexturing
    gAddress "glActiveTextureARB",glActiveTexture
    gAddress "glMultiTexCoord2fARB",glMultiTexCoord2f
    gAddress "glMultiTexCoord2fvARB",glMultiTexCoord2fv
    '
    gAddress "glCreateShader",glCreateShader
    gAddress "glShaderSourceARB",glShaderSource   ' ARB
    gAddress "glCompileShaderARB",glCompileShader ' ARB
    gAddress "glGetInfoLogARB",glGetInfoLog       ' ARB only
    'glGetObjectParameteriv ??
    gAddress "glGetShaderiv",glGetShaderiv
    gAddress "glAttachShader",glAttachShader
    gAddress "glDetachShader",glDetachShader
    gAddress "glDeleteShader",glDeleteShader
    gAddress "glLinkProgram",glLinkProgram
    gAddress "glCreateProgram",glCreateProgram
    gAddress "glDeleteProgram",glDeleteProgram
    gAddress "glGetProgramiv",glGetProgramiv
    gAddress "glUseProgram",glUseProgram
    '
    gAddress "glGetUniformLocation",glGetUniformLocation
    gAddress "glGetUniformfv",glGetUniformfv
    gAddress "glGetUniformiv",glGetUniformiv
    gAddress "glUniform1f",glUniform1f
    gAddress "glUniform2f",glUniform2f
    gAddress "glUniform3f",glUniform3f
    gAddress "glUniform4f",glUniform4f
end sub


FUNCTION CreateShaderProg(ShaderFile AS STRING, byref VObj AS LONG, byref FObj AS LONG) AS LONG
    ' http://www.opengl.org/sdk/docs/tutorials/ClockworkCoders/loading.php
'    
    IF GLSL=0 THEN EXIT FUNCTION
    dim as long e,i,j,k,m,n
    dim as string fi,sh,InfoLog,sbuf
    dim as string FragmentShaderSource
    dim as string VertexShaderSource
    dim as long VertexShaderObject, FragmentShaderObject
    dim as any pointer p
    dim as string*2 CRLF =chr$(13)+chr$(10)
    '
    fi=DIR$(ShaderFile): IF LEN(fi)=0 THEN EXIT FUNCTION
    i=FREEFILE:OPEN ShaderFile FOR BINARY AS i
    sh=string$(lof(i),chr$(0))
    GET #i, 1,sh
    CLOSE(i)
    IF LEN(sh)=0 THEN EXIT FUNCTION
    i=INSTR(sh,"[VERTEX SHADER]")
    IF i THEN
        j=INSTR(i,sh,"[END VERTEX SHADER]")
        IF j=0 THEN j=LEN(sh)+1
        i=i+15:VertexShaderSource=MID$(sh,i,j-i)
    END IF
    i=INSTR(sh,"[FRAGMENT SHADER]")
    IF i THEN
        j=INSTR(i,sh,"[END FRAGMENT SHADER]")
        IF j=0 THEN j=LEN(sh)+1
        i=i+17:FragmentShaderSource=MID$(sh,i,j-i)
    END IF
    '
    asm
        ' vertexShaderObject = glCreateShader(GL_VERTEX_SHADER);
        push GL_VERTEX_SHADER
        call [glCreateShader]
        mov [VertexShaderObject],eax
        'fragmentShaderObject = glCreateShader(GL_FRAGMENT_SHADER);
        push GL_FRAGMENT_SHADER
        call [glCreateShader]
        mov [FragmentShaderObject],eax
    end asm
    'glShaderSourceARB(vertexShaderObject, 1, &VertexShaderSource, &vlength);
    j=LEN(VertexShaderSource)
    p=VARPTR(j)
    asm  push [p]
    p=VARPTR(VertexShaderSource)
    asm
        push eax
        push 1
        push [vertexShaderObject]
        call [glShaderSource]
    end asm
    ' glShaderSourceARB(fragmentShaderObject, 1, &FragmentShaderSource, &flength);
    j=LEN(FragmentShaderSource)
    p=VARPTR(j)
    asm push [p]
    p=VARPTR(FragmentShaderSource)
    asm
        push [p]
        push 1
        push [FragmentShaderObject]
        call [glShaderSource]
        ' glCompileShaderARB(VertexShaderObject);
        push [VertexShaderObject]
        call [glCompileShader]
        ' glCompileShaderARB(fragmentShaderObject);
        push [FragmentShaderObject]
        call [glCompileShader]
    end asm

    ' glGetObjectParameteriv(ShaderObject, GL_COMPILE_STATUS, &compiled); OBSOLETE?
    'p=varptr(j)
    'asm  push [p]
    'asm  push GL_COMPILE_STATUS
    'asm  push [VertexShaderObject]
    'asm  call [glGetObjectParameteriv]
    ' if (compiled) { /* yes it compiledasm  */ }

    'glGetShaderiv(ShaderObject, GL_INFO_LOG_LENGTH , &blen);
    p=VARPTR(j)
    asm
        push [p]
        push GL_INFO_LOG_LENGTH
        push [VertexShaderObject]
        call [glGetShaderiv]
    end asm
    IF j>1 THEN
        'glGetInfoLogARB(ShaderObject, blen, &slen, compiler_log);
        InfoLog=string$(1024,chr$(0))
        sbuf=infolog
        p=STRPTR(InfoLog)
        asm  push eax
        p=VARPTR(j)
        asm
            push [p]
            push 1024
            push [VertexShaderObject]
            call [glGetInfoLog]
        end asm
        InfoLog=RTRIM$(InfoLog) ' nulls?
        'REPLACE $LF WITH $CRLF IN Infolog
        i=1:m=1
        do
            if i>1024 then exit do
            k=asc(Infolog,i)
            if k=0 then m+=1: exit do
            if k=10 then mid$(sbuf,m)=chr$(13)+chr$(10):m+=2
            if k>10 then mid$(sbuf,m)=chr$(k): m+=1
            i+=1
        loop
        k=i
        i=FREEFILE
        OPEN BBP_PLUGIN_FOLDER+"shader\shader_errors.txt" FOR OUTPUT AS i
        PRINT #i,Shaderfile+CRLF+TIME$+"  "+DATE$+CRLF+CRLF+left$(sbuf,m)
        CLOSE i
        EXIT FUNCTION
    END IF

     'Linking:
    asm
        ' ProgramObject = glCreateProgram();
        call [glCreateProgram]
        mov [j],eax
        ' glAttachShader(ProgramObject, vertexShaderObject);
        push [VertexShaderObject]
        push [j]
        call [glAttachShader]
        ' glAttachShader(ProgramObject, fragmentShaderObject);
        push [FragmentShaderObject]
        push [j]
        call [glAttachShader]
        ' glLinkProgram(ProgramObject);
        push [j]
        call [glLinkProgram]
    end asm
    ' glGetProgramiv(ProgramObject, GL_LINK_STATUS, &linked);
    p=VARPTR(k)
    asm
        push [p]
        push GL_LINK_STATUS
        push [j]
        call [glGetProgramiv]
    end asm
    Vobj=VertexShaderObject
    fObj=FragmentShaderObject
    FUNCTION=j ' ProgramObject
END FUNCTION


' PERFORMANCE
