  'zxGLWindow CLass by Kent Sarikaya and Charles Pegge
  'Last Modified 06/18/2011

  #include "../../inc/minwin.inc"

  #define WINGDIAPI
  #define APIENTRY

  typedef word wchar_t
  typedef sys ptrdiff_t

  includepath + "../../inc/glo2/"
  library "opengl32.dll"
  include once "gl/gl.h"
  'include once "gl/glext.h"
  library "glu32.dll"
  include once "gl/glu.h"
  include once "gl/wgl.inc"
  library ""


  '===============
  class zxGLWindow
  '===============



        public

        ''====

        '====
        'vars
        '====
        '
        dim  sys Keys[ 256 ]

        static sys   FullScreen, Top, lft, sWidth, sHeight, oWidth, oHeight
        static sys   PixelFormat, BPP 'bits per pixel

        static string Caption,ClassName

        static sys    MouseX, MouseY, MouseButton, sKeydown
        static sys    MenuCommand
        static sys    ChangeSize, IsActive, IsRunning, destro
        static sys    RenderFun,InputFun
        static float  FOV, NearDistance, FarDistance

        sys  hInstance, hDC, hrc, hWnd, Font
        RECT windowRect
        MSG  mesg
        sys  dwExStyle, dwStyle

        '=======
        'methods
        '=======


        method constructor(sys RenderProc=0, sys InputProc=0 )
        '=====================================================
        InputFun=InputProc
        RenderFun=RenderProc
        Fullscreen = 0
        FOV = 45
        NearDistance = 0.1
        FarDistance = 100
        end method


        method destructor()
        '==================
        freelibrary kernel32
        freelibrary user32
        freelibrary gdi32
        end method


        method Create
        '============
        (
        sys iWidth=800,
        sys iHeight=600,
        sys iBits=32,
        sys iFullscreen = 0,
        string cCaption = "Simple GLWindow",
        sys iLeft = 0,
        sys iTop = 0,
        sys icon = 0,
        sys menu = 0 ) as sys

        sWidth = iWidth
        sHeight = iHeight
        BPP = iBits
        Lft = iLeft
        Top = iTop
        Caption = cCaption
        ClassName = "GLWindow"

        windowRect.left = Lft
        windowRect.right = sWidth
        windowRect.top = Top
        windowRect.bottom = sHeight

        Fullscreen = iFullscreen

        hInstance = GetModuleHandle 0
        '
        WNDCLASS winClass
        winClass.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC
        winClass.lpfnWndProc = @WindowProc
        winClass.cbClsExtra = 0
        winClass.cbWndExtra	= 0
        winClass.hInstance = hInstance
        winClass.hIcon = LoadIcon NULL, IDI_WINLOGO 
        winClass.hCursor = LoadCursor NULL, IDC_ARROW 
        winClass.hbrBackground = NULL
        winClass.lpszMenuName = NULL
        winClass.lpszClassName = *ClassName
        if not RegisterClass @winClass then
          'error
          MessageBox NULL, "RegisterClass", "ERROR", MB_OK
          return 0
        end if
        '
        CreateWin()
        end method


        method CreateWin()
        '=================
        '
        sys a
        if Fullscreen then
          oWidth=swidth : oHeight=sHeight
          sWidth=800 : sHeight=600
          '
          DEVMODE sc 'screensettings
          sc.dmSize       = sizeof sc
          sc.dmPelsWidth  = sWidth
          sc.dmPelsHeight = sHeight
          sc.dmBitsPerPel = BPP
          sc.dmFields = DM_PELSWIDTH or DM_PELSHEIGHT or DM_BITSPERPEL
          if ChangeDisplaySettings( @sc, CDS_FULLSCREEN )<> DISP_CHANGE_SUCCESSFUL then
            '
            ' error go window mode
            ' If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
            '
            FullScreen=0
            if MessageBox (NULL, "Fullscreen Not Supported. Use Windowed Mode?","ERROR", MB_YESNO | MB_ICONEXCLAMATION ) = IDYES  then
            else
              ' The Program Is Closing
              MessageBox NULL, "Program Closing", "ERROR", MB_OK | MB_ICONSTOP
              return 0
            end if
          end if
        end if
        '
        if Fullscreen then
          dwExStyle = WS_EX_APPWINDOW
          dwStyle = WS_POPUP
          ShowCursor 0
        else
          dwExStyle = WS_EX_APPWINDOW | WS_EX_WINDOWEDGE
          dwStyle = WS_OVERLAPPEDWINDOW
          if owidth then sWidth=oWidth : sHeight=oHeight
        end if
        '
        windowrect<=0,0,sWidth,sHeight
        AdjustWindowRectEx @windowRect, dwStyle, 0 , dwExStyle
        '
        hWnd = CreateWindowEx(
          dwExStyle,
          *ClassName,
          *caption,
          dwStyle | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
          Lft,
	  Top,
          windowRect.right - windowRect.left,
          windowRect.bottom - windowRect.top,
          NULL, 'hparent
          NULL, 'hmenu
          hInstance,
          NULL ) 'lparam

        if hwnd=0 then
          Destroy()
          'Error the window could not be created
          MessageBox NULL, "CreateWindowEx", "ERROR", MB_OK
          return 0
        end if

        static PIXELFORMATDESCRIPTOR pfd
        pfd.nSize = sizeof PIXELFORMATDESCRIPTOR
        pfd.nVersion = 1
        pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER
        pfd.iPixelType = PFD_TYPE_RGBA
        pfd.cColorBits = BPP
        pfd.cRedBits = 0
        pfd.cRedShift = 0
        pfd.cGreenBits = 0
        pfd.cGreenShift = 0
        pfd.cBlueBits = 0
        pfd.cBlueShift = 0
        pfd.cAlphaBits = 0
        pfd.cAlphaShift = 0
        pfd.cAccumBits = PFD_MAIN_PLANE
        pfd.cAccumRedBits = 0
        pfd.cAccumGreenBits = 0
        pfd.cAccumBlueBits = 0
        pfd.cAccumAlphaBits = 0
        pfd.cDepthBits = 16
        pfd.cStencilBits = 1
        pfd.cAuxBuffers = 0
        pfd.iLayerType =  PFD_MAIN_PLANE
        pfd.bReserved  = 0
        pfd.dwLayerMask = 0
        pfd.dwVisibleMask = 0
        pfd.dwDamageMask  = 0

        if not hDC := GetDC hWnd   then
          Destroy()
          'error no device context
          MessageBox NULL, "GetDC", "ERROR", MB_OK
          return 0
        end if

        if not hDC := GetDC hWnd then
          Destroy()
          'error no device context
          MessageBox NULL, "GetDC", "ERROR", MB_OK
          return 0
        end if

        'find a compatible pixel format
        if not PixelFormat := ChoosePixelFormat hDC, @pfd then
          Destroy()
          'error no good pfd
          MessageBox NULL, "ChoosePixelFormat", "ERROR", MB_OK
          return 0
        end if

        if not SetPixelFormat hDC, PixelFormat, @pfd  then
          Destroy()
          'error could not set
          MessageBox NULL, "SetPixelFormat", "ERROR", MB_OK
          return 0
        end if

        if not hRC := wglCreateContext hDC then
          Destroy()
          'error
          MessageBox NULL, "wglCreateContext", "ERROR", MB_OK
          return 0
        end if

        if not wglMakeCurrent hDC, hRC  then
          Destroy()
          'error
           MessageBox NULL, "wglMakeCurrent", "ERROR", MB_OK
          return 0
        end if

        ShowWindow hWnd, SW_SHOW
        SetForegroundWindow hWnd
        SetFocus hWnd

        'setup the program's perspective view
        Resize()
        glShadeModel GL_SMOOTH
        glClearColor 0, 0, 0, 0
        glClearDepth 1
        glEnable GL_DEPTH_TEST
        glDepthFunc GL_LEQUAL
        glHint GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST

        IsActive = 1
        IsRunning = 2 'message loop with callbacks
        end method


        method DestroyWin()
        '==================
            isRunning=1 'message loop but no callbacks
            if Fullscreen then
                ChangeDisplaySettings NULL, 0
                ShowCursor 1
            end if
            '
            wglMakeCurrent 0,0
            wglDeleteContext hRC : hRC=0
            ReleaseDC hWnd,hDC   : hDC=0
            PostQuitMessage hwnd,0
            DestroyWindow hWnd : destro=0 : hwnd=0 : isrunning=0
            '
            'if hRC
            '    if wglMakeCurrent NULL, NULL = 0 then
            '       'error
            '        MessageBox NULL, "Destroy wglMakeCurrent", "ERROR", MB_OK
            '    end if
            '    if wglDeleteContext hRC = 0 then
            '        'error
            '        MessageBox NULL, "Destroy wglDeleteContext", "ERROR", MB_OK
            '    end if
            '    hRC = NULL
            'end if

            'if hDC<>0 && ReleaseDC( hWnd,hDC )=0 then
            '   'error
            '    MessageBox NULL, "Destroy ReleaseDC", "ERROR", MB_OK
            '    hDC = NULL
            'end if

            'if hWnd<>0 && DestroyWindow(hWnd)=0 then
            '   'error
            '    MessageBox NULL, "Destroy DestroyWindow", "ERROR", MB_OK
            '    hWnd = NULL
            'end if
        end method


        method Destroy()
        '===============
            '
            DestroyWin()
            UnregisterClass *ClassName, hInstance ': hInstance=0


            'if UnregisterClass (*ClassName, hInstance) =0 then
            '   'error
            '    MessageBox NULL, "Destroy UnregisterClass", "ERROR", MB_OK
            '    hInstance = NULL
            'end if
            '
            '
        end method    


        '=============
        'font routines
        '=============


        method CreateTTFont( char* szFontName = "Lucida Console", int iSize = 16 ) as sys
        '================================================================================

            typedef sys HFONT
            HFONT hFont
            glFont = glGenLists 256


'def __in
'HFONT CreateFont(
'  __in  int nHeight,
'  __in  int nWidth,
'  __in  int nEscapement,
'  __in  int nOrientation,
'  __in  int fnWeight,
'  __in  DWORD fdwItalic,
'  __in  DWORD fdwUnderline,
'  __in  DWORD fdwStrikeOut,
'  __in  DWORD fdwCharSet,
'  __in  DWORD fdwOutputPrecision,
'  __in  DWORD fdwClipPrecision,
'  __in  DWORD fdwQuality,
'  __in  DWORD fdwPitchAndFamily,
'  __in  LPCTSTR lpszFace
');


            hFont = CreateFont       isize,     'height
                                     isize,     'width
                                     0,         'escapement
                                     0,         'orientation
                                     FW_NORMAL, 'weight 
                                     0,         'italic
                                     0,         'underline
                                     0,         'strikeout
                                     ANSI_CHARSET,
                                     OUT_TT_PRECIS,
                                     CLIP_DEFAULT_PRECIS,
                                     ANTIALIASED_QUALITY,
                                     FF_DONTCARE | DEFAULT_PITCH,
                                     szFontName

            SelectObject hDC, hFont
            wglUseFontBitmapsA hDC, 0, 256, glFont
            finit
            return glFont         
        end method

        method DestroyTTFont( sys iFont )
        '================================
            if iFont then 
                glDeleteLists iFont, 256
            end if
        end method

        method TTFont( sys iFont )
        '=========================
          font=ifont
        end method

        method TTFont() as sys
        '=====================
          return font
        end method

        
        method Print( int x, y, char* printString)
        '=========================================
            if printString = NULL then return
            glPushMatrix
                glLoadIdentity
                'position and render the text
                glRasterPos2d x, y
                glListBase Font 
                glCallLists len( printString ), GL_UNSIGNED_BYTE, printString
            glPopMatrix
        end method
        
        method BeginTextMode()
        '=====================
            glMatrixMode GL_PROJECTION
            glPushMatrix
                glLoadIdentity
                glOrtho 0, sWidth, 0, sHeight, -1, 1
                glMatrixMode GL_MODELVIEW       
        end method
        
        method EndTextMode()
        '===================
            glMatrixMode GL_PROJECTION
            glPopMatrix
            glMatrixMode GL_MODELVIEW       
        end method

        method HandleMessages()
        '======================
          '
          while IsRunning
            if isrunning=2 then
              if RenderFun then call RenderFun
              if InputFun then call InputFun
              if destro then destroy()
            end if
            MenuCommand = NULL
            while PeekMessage @mesg, NULL, 0, 0, PM_REMOVE
                TranslateMessage @mesg
                DispatchMessage @mesg
            wend
          wend
          '
        end method


        method SwitchFullScreen( ) as sys
        '================================
            FullScreen=1-FullScreen
            return FullScreen
        end method


        method width( ) as sys
        '=====================
            return sWidth
        end method


        method Height( ) as sys
        '======================
            return sHeight
        end method


        method MenuDown( WORD ID ) as sys
        '================================
            if menuCommand = ID then return 1
        end method


        method KeyDown( sys ucKey ) as sys
        '=================================
            if Keys[ ucKey ] then return 1
        end method

        
        method KeyUp( sys ucKey ) as sys
        '===============================
            if Keys[ ucKey ]=0 then return 1
        end method

        method KeyEvent( ) as sys 'read once and clear
        '=============================================
            method=sKeyDown
            sKeyDown=0
        end method

        
        method MouseDown( sys button ) as sys
        '====================================
            if MouseButton and button then return 1
        end method

        
        method MouseUp( sys button ) as sys
        '==================================
            if (MouseButton xor -1) and button  then return 1
        end method

        method SwapBuf()
        '===================
            glFlush
            SwapBuffers hDC
        end method


        method Resize()
        '==============
            ' checking for divide by zero
            if sHeight = 0 then sHeight = 1

            glViewport 0, 0, sWidth, sHeight

            glMatrixMode GL_PROJECTION
            glLoadIdentity

            double ar=sWidth/sHeight
            gluPerspective FOV,ar, NearDistance, FarDistance

            glMatrixMode GL_MODELVIEW
            glLoadIdentity
            ChangeSize = 0
        end method

    
        method Refresh()
        '===============
            Resize()
        end method
              
     private


        function WindowProc( sys hWnd, uMsg, wParam, lParam ) as sys callback
        '====================================================================
                '
        	select uMsg
                '
                case WM_SYSCOMMAND
                    select wParam
                        case SC_SCREENSAVE
                        case SC_MONITORPOWER
                    end select
                    
                case WM_COMMAND
                    MenuCommand = LOWORD wParam

                case WM_KEYDOWN
                    keys[wParam]=1
                    sKeydown=wparam
                    return 0

                case WM_KEYUP
                    keys[wParam]=0
                    return 0

                case WM_MOUSEMOVE:
                    MouseX = LOWORD lParam
                    MouseY = HIWORD lParam
                    MouseButton = wParam
                    return 0


                case WM_MOVE
                    if isrunning=2 then
                      if RenderFun then call RenderFun
                    end if

                case WM_SIZE
                    sWidth = LOWORD lParam
                    sHeight = HIWORD lParam 
                    ChangeSize = 1
                    resize()
                    if isrunning=2 then
                      if RenderFun then call RenderFun
                    end if
                    return 0

                case WM_DESTROY
                  destro=1
                  return 0

                end select
                '
                '
                return DefWindowProc hWnd, uMsg, wParam, lParam
                '
        end function
 

  end class
'#recordof zxGLWindow

