


  '        ##
  '       ####
  '      ######
  '     ########
  '    ##########
  '   ############
  '  ##############
  ' ################
  'GLOBAL DEFINITIONS
  '==================


  '-----------------
  'GLOBAL DATA TYPES
  '=================

  type hashref
    h  as sys   ' hash code
    l  as sys   ' linked list index (fwds only)
    m  as sys   ' macro list index
    b  as sys   ' brc nesting level
  end type
  '
  'e  as sys   ' storage for equates (shortform)
  't  as sys   ' tally

  type preced
    pr as sys
    sw as sys
    le as sys
  end type

  type macotype
    a as sys
    b as sys
    c as sys
    d as sys
    e as sys
    f as sys
    g as sys
    h as sys
    i as sys
    j as sys
    k as sys
  end type

  type stack
    a as sys
    b as sys
    c as sys
    d as sys
    e as sys
    f as sys
    g as sys
    h as sys
    i as sys
    j as sys
    k as sys
    l as sys
  end type


  '-----------------
  'GENERAL CONSTANTS
  '=================

  const as sys    iq4=250     'INTERNAL QUOTE CODE
  const as sys    lnm=251     'ORIGINAL LINE MARKER (IN COMMENT)
  '
  const as string sq=chr(252) 'TRANSFER MARKER START
  const as string eq=chr(253) 'TRANSFER MARKER END
  const as string iq=chr(iq4) 'INTERNAL QUOTE MARK
  const as string dfd=chr(249)'DATA FIELD DELIMITER
  '
  const as string htb=chr(9)
  const as string crg=cr+";"+cr
  const as string qu=chr(34)
  const as string cm=chr(44)
  const as string sp=cr+"("+cr
  const as string ep =cr+")"+cr
  const as string stp=" : "
  const as string sep =" "



  '----------
  'META TYPES
  '==========

  const  metatypes as string=_
  " >0   structured variable,"_
  "  0   primitive variable or constant,"_
  " -1   def macro,"_
  " -2   defs enumeration,"_
  " -3   type / class,"_
  " -4   o2 intrinsic function,"_
  " -5   proc sub or function,"_
  " -6   imported sub or function,"_
  " -7   vectored sub or function - declare ... AT v,"_
  " -8   struct from typedef,"_
  " -9   reserved word,"_
  " -10  x86 register,"_
  " -11  attributes,"_
  " -12  operator,"_
  " -13  o2 major keywords,"_
  " -14  o2h major keywords,"_
  " -15  C type keywords,"_
  " -16  intrinsic functions,"_
  " -17  intrinsic float macro,"_
  " -18  labels,"_
  " -19  termination macro,"_
  " -20  high level macro,"_
  ""

  'also numeric equates


  'OP CODING TO JUMP INSTRUCTION = <> > >= <= <

  const as string jmpname=_
  " 12 jb  "_
  " 13 jae "_
  " 14 jz  "_
  " 15 jnz "_
  " 16 jbe "_
  " 17 ja  "_
  " 1C jl  "_
  " 1D jge "_
  " 1E jle "_
  " 1F jg  "_
  " 92 jae "_
  " 93 jb  "_
  " 94 jnz "_
  " 95 jz  "_
  " 96 ja  "_
  " 97 jbe "_
  " 9C jge  "_
  " 9D jl  "_
  " 9E jg  "_
  " 9F jle "_
  ""

  '---------
  'OPERATORS
  '=========
  '
  'this list is used to return an opnumber from an opname (identops)
  'these opnumbers are all hardcoded
  '
  const as string opname=_
  " 0 load "_
  " 1 load "_
  " 2 `=` "_
  " 3 cmp "_
  " 4 push "_
  " 5 dump "_
  " 6 pop "_
  " 8 `+=` "_
  " 9 `-=` "_
  " 10 swap "_
  " 11 not "_
  " 11 ! "_
  " 12 inc "_
  " 13 dec "_
  " 14 `*=` "_
  " 15 `/=` "_
  " 16 `==` "_
  " 17 `<>` "_
  " 28 `<` "_
  " 29 `>=` "_
  " 30 `<=` "_
  " 31 `>` "_
  " 33 and "_
  " 33 & "_
  " 34 or "_
  " 34 | "_
  " 35 xor "_
  " 65 `and=` "_
  " 66 `or=` "_
  " 67 `xor=` "_
  " 42 * "_
  " 43 + "_
  " 45 - "_
  " 47 / "_
  " 92 \ "_
  " 71 `&&` "_ 'boolean and
  " 72 `||` "_ 'boolean or
  " 74 `<<` "_
  " 75 `>>` "_
  " 94 ^ "_   'normally power of
  ""

  '----------
  'DATA TYPES
  '==========
  '
  '---------------
  'BASE DATA TYPES
  '===============

  'also used for reverse dictionary to obtain type name from type code

  const as string idtype=_
  " void 0,"_ 'special case
  " byte 1,"_
  " short 2,"_
  " long 4,"_
  " byte 21,"_
  " word 22,"_
  " dword 24,"_
  " qword 28,"_ 'using FPU
  " quad 48,"_
  " single 64,"_
  " double 68,"_
  " ext 6A,"_
  " fpu 40,"_
  " zstring A1,"_
  " zstring2 A2,"_
  " bstring C1,"_
  " bstring2 C2,"_
  " string E1,"_
  " wstring E2,"_
  " mmx 130,"_
  " xmm 150,"_
  ""

  '
  '-------------------
  'CALLING CONVENTIONS
  '===================
  '
  const as string callco=_
  " stdcall 100"_
  " cdecl 101"_
  " ms64 102"_
  " pascal 108"_
  " cpu 110"_
  " fpu 111"_
  ""
  '







  '--------------------
  'FLOATING POINT MACROS
  '====================

  const as string exponents=_
  "sub esp,16 : fstcw [esp] : fstcw [esp+2] : or [esp],0xc00 : fldcw [esp]"+cr+_
  "fldl2e : fmulp st1 : fld st0 : frndint : fsub st1,st0"+cr+_
  "fxch : f2xm1 : fld1 : faddp st1 : fscale : fstp st1"+cr+_
  "fldcw [esp+2] : add esp,16"

  const as string powers=_
  "sub esp,16 : fstcw [esp] : fstcw [esp+2] : or [esp],0xc00 : fldcw [esp]"+cr+_
  "fxch : fst qword [esp+8] : fabs : fyl2x : fld st0 : frndint : fsub st1,st0"+cr+_
  "fxch : f2xm1 : fld1 : faddp st1,st0 : fscale : fstp st1"+cr+_
  "and byte [esp+15],128  : jz fwd nng : fchs : .nng : fldcw [esp+2] : add esp,16"




  '========
  'CAPACITY
  '========

  '
  'MAXIT=100K: ABOUT 10-20 MEG MEMORY SPACE INCLUDING ASSOCIATED STRINGS
  '
  const as sys maxit=100000  'size of entity array
  const as sys smaco=10      'elements in maco
  const as sys smach=4       'elements in macho data structure
  const as sys smacd=smaco-1 'dim size spec
  const as sys omacs=smaco-4 'offset to maco string pointers (entity strings)



  '======
  'ARRAYS
  '======


  'ENTITY STORAGE
  '
  '===================================================================
  global as sys     opd(999,9), ope   'Assembly code data
  global as string  opn(999),ops(999) 'Assembly code data
  '-------------------------------------------------------------------
  global as sys    maco(maxit,smacd) ' buffer for all definitions
  global as hashref mach(maxit)       ' hashes
  '===================================================================
  '
  '
  'GENERAL

  '===================================================================
  global as sys    prc(127,1)    ' precedence buffer 0=op 1= pr level
  global as sys    ctb(99)       ' control block type
  global as stack  st(99)        ' general nesting stack
  global as stack  stk           ' general nesting stack
  global as sys    jn            ' string join flag
  global as sys    sta(99)       ' precedence stack
  global as sys    slc(99)       ' `select` stack cas
  global as sys    sle(99)       ' `select` stack enumeration
  global as preced pre(99)       ' operator precedence
  global as string nes(99)       ' nested names
  global as string nxs(99)       ' nested next step
  '-------------------------------------------------------------------
  global as string por(99)       ' param original word (ow)
  global as string paw(99)       ' param wg word
  global as string pas(99)       ' parameter expression
  global as sys    pao(99)       ' param last operator
  global as sys    pat(99)       ' param type
  global as sys    pst(99)       ' param stack size allocated
  global as string pav(99)       ' param conversion code
  global as string pax(99)       ' param indirect addr code
  '-------------------------------------------------------------------
  global as sys    libu(511)     ' library use flag
  global as sys    libo(511)     ' library offset list
  global as string libs(511)     ' library name list
  global as string libl(511)     ' library used proc list
  '-------------------------------------------------------------------
  global as string  wva(99)      ' var / dim statements
  global as sys     mle=512      ' macro link list boundary
  global as sys     scop(99,9)   ' nesting scope index
  '===================================================================
  global as string  sregs(100)   ' nesting indexers
  global as string  wp(63)       ' macro params
  global as string  ssf(63)      ' include file name
  global as string  sst(63)      ' include (preserve parent text)
  global as string  stb(63)      ' include (preserve included text)
  global as string  ssn(999)     ' include file name log
  global as sys     ssh(999)     ' include content hash log
  global as string  rgp(15)      ' register param macros (for 64 bit fast calls)
  global as string  regn(15)     ' register param names (for 64 bit fast calls)
  global as sys     typl(15)     ' local param type
  global as long    cbrk(63),cbri' block nests {}
  '===================================================================
  'PROCEDURE FLAGS
  global as sys funi,atf(7),lcl(7),lcls(7),blcl(7),plcl(7),mlcl(7)
  global as sys reto(7),retb,th(7),ml(7),ccp(7)
  global as sys typp(7),noin(7),funn(7),dts(7),dcs(7)
  global as string funm(7)
  '===================================================================
  global as any ptr psysfuns     ' runtime ebx table base ptr
  global as any ptr sysfuns(1023)' runtime fun table
  global as string  mdl_path     ' 
  '===================================================================
  global as string expwn(999)    ' export labels
  global as string expal(999)    ' export dll symbols
  global as sys    expi(999)     ' export index for sorting
  '===================================================================





'=======================------------
'SIMPLE GLOBAL VARIABLE DESCRIPTIONS
'===================================

'  fq      include file index
'  me      macro list end boundary
'  mp,mq   macro iteration index
'  mc,md  sem codes
'  mct     macro anti recursion counter
'  mex     macro anti recursion source buffer limit
'  swd     start of current word
'  nwd     start of next word
'  ewd     space count at end of word
'  dtf     dot flag for dotted words
'  aoff    aoffl,aoffs' offsets for indexers
'  asce    ascel,asces ' offset ascend/descend flag
'  regs    regsl,regss regst' indexers
'  woff    offset of element
'  voff    offset of variable
'  toff    offset of vf table
'  pw      pw procedure word
'  bgl     beginning of current line
'  lct     line count
'  incli ' prevent %params from being substituted in next macro
'  mcf macro param insertion flags
'  nan     not a number flag
'  lmax    macro hash buckets max links
'  ascw    ascii of word
'  ascn    ascii of next word
'  ascy    ascii of symbol
'  elsize variable size from last element
'  varf    variable func mode
'  sigf    signature enable flag
'  sig     signature of func
'  sog     signature of element
'  ou      original indirection prefixes
'  ow      original word
'  vew     compile mode: 0 normal 2 include source with errors in o2 script (runtime)
'  noop    no operators flag
'  o2h     O2H flag
'  typ     operation type integer float or string
'  tye    type of element
'  phr     conditional lhv rhv
'  cpa     comparator flag
'  leni    length of last insertion
'  inpi    forward insertion point
'  clon    clone flag (getas)
'  noo     new flag (getas)
'  lent    length of object (identype)
'  lenw    length of word (word)
'  op      operator coding
'  oq      last operator code
'  ind     indirection
'  wi      with flag
'  bg      beginning of current output line
'  j       output index
'  pt      any pointer
'  nst     nesting index
'  nx     `next` stack index
'  slx    `select` stack index
'  rga    cpu accum select
'  nquot  not a quote flag
'---------------------------------------------
'  wu      global word string
'  wu1     global word string
'  wu2     global word string
'  t       output string
'  wpfx    pointer prefix for byref vars etc
'  wth     `with` assignment prefix
'  asg     assignment string to append / post append to expression
'  asi     assigner/eqator flag
'  wg      last wr pword
'  opg     last op in expression
'  typg    assignment type
'  cnc     conditional code
'  cnd     conditional flag
'  tmpst   tmp storage offset
'  tmpstk  tmp storage offset use in 64 bit mode when param is pushed
'  fpu     fpu directive flag
'  pc      param stack index
'  cco     calling convention
'  vwb     selected view start
'  vwe     selected view end
'  uk      call compatibility mode
'  libe    library list boundary
'  libr    library name for declared imports
'  impo    import block flag
'   dcl    declaratives flag
'   mth    sub/function/method flag
'   priv   private flag
'   brc    scope nesting index
'------------------------------------------------
'  da      value accumulator
'  dv      value register (64 bit float)
'  qv      value register (64 bit integer)
'------------------------------------------------
'  asgm    multiple assignment flag
'  asgo    offset
'  asgi    stride
'  asgj    structure array stride
'  asgk    structure string offset
'  asgn    structure element offset
'  asgp     assignment string to append / post append to expression (multiassign)
'  asgs    structure string
'------------------------------------------------
' opns     name of operations
' opnsl    operations name list
' adra     adress flag
' lbw      last label
' ipath    includepath
' lpath    librarypath
' nprec    no precedence flag
' nrs      not resolved flag
' dep      dependent code flag
' cnst     constantflag (Const like Dim)
' ovr      inheritance override flag
' ixb      index base
' vtp      virtual table pointer
' bref     byref flag
' ths      implicit this flag
' pef      pe format flag 1=dll 2=exe
' pem      pe mode flag 64=64 bit mode
' pexn     pe file name
' pdr      in procedure flag
' mel      lower boundary for inner local vars
' pps      popstack flag
' tmnt     terminate flag
' dlb      dll list base
'' dlbf    dll list base late binding flag
' omo      oxygen io string mode
' rexi     64 bit mode register flag
' expf     export section flag
' rsrf     resource section flag
' indt     indirection of type
' enu      enumeration type indicator
' enuc     enumeration type indicator for case
' lclv     local variables flag
' ary      TYPE array descriptor accum string   
' extn     extern flag, C
' sps      string pool buffer string
' spe      string pool end index
' spl      string pool buffer length
' hlo      header language output
' cpuw     cpu width 32/64
' spw1     stack pointer width
' spw2     stack pointer width x 2
' pesp     [esp] or [rsp]
' casf     case mode flag
' dvl      default values retrieved from signature
' mess     state command for declarations, dims etc
' mesb     state intrinsic base index for declarations, dims etc
' mest     state local base index for declarations, dims etc
' vaf      carrier for varf (procedures() callcoc()
' vstp     force variable location step increment
' pres     string buffer 'preserve' flag
' assx     assign flag
' mph      hash index
' num      generic number format spec
' cas      case flag
' nth      that' flag suppresses 'this'
' oxypath  oxygen path list
' hostdll  oxygen path resolver macro
' bvg      byval flag in expressions for procedures
' uniq     unique flag to prevent duplicate definitions (at same nesting level)
' ispr     expression contains string procedure. flag
' typk     cast type
' dats     initialised data block
' datc     initialised data block item counter
' dati     initialised data block boundary
' lnkc     code side data link table
' lnkd     data side data link table
' nsto     prevent data being added to data section
' stkb     stacked bytes - parameters
' dts      delete temp strings flag
' dls      delete local strings flag
' stp      separator string
' parx     parameter expression flag
' ard      array displacement for objects
' divi     division operator flag (detect in precedence)
' defbuf   buffer for stray #defines
' dwl      lower dword
' dwu      upper dword
' met      metaval flag
' nl       new line flag
' lnmks    last line number encounteres
' pakd     no padding flag for types and classes
' ccx      calling convention code
'===================================================================



'----------------------
'SIMPLE GLOBAL VARIABLES
'======================


  global as sys mc,md,me,mp,mq,mct,mex,swd,nwd,ewd,dtf,aoff,aoffl,aoffs,asce,ascel,asces
  global as sys woff,voff,toff,bgl,lct,incli,mcf,nan,lmax,ascw,ascn,ascy,elsize,varf,vaf,sigf,fq
  global as sys noop,o2h,typ,tye,phr,cpa,leni,inpi,clon,noo,lent,lenw
  global as sys op,oq,ind,wi,bg,j,opg,typg,asi,nst,nx,slx,rga,nquot
  global as sys lbr=40,rbr=41,iq1=34,iq2=96,iq3=96,ct1=39,ct2=59,sr1=58,sr2=58
  global as sys prec,prl,nsl,ipe,cnc,cnd,tmpst,tmpstk,fpu,pc,cco
  global as sys vwb,vwe,uk,libe,impo,dcl,mth,priv,brc,dep,pps
  global as sys asgk,asgm,asgo,asgi,asgj,asgn,adra,nprec,nrs,cnst
  global as sys ovr,ixb,vtp,bref,ths,pef,pem,pdr,mel,tmnt,dlb
  global as sys rexi,expf,rsrf,indt,enu,enuc,lclv,extn,spe,spl,hlo
  global as sys cpuw,casf,mesb,mest,vstp,pres
  global as sys assx,mph,nodel,cas,nth,bvg,uniq,ispr,typk,datc,dati
  global as sys nsto,stkb,parx,ard,divi,met,trgn,nl,pakd,ccx


  global as longint qv
  global as double da,dv
  global as any ptr pt


  global as string t,wu,wu1,wu2,ou,ow,regs,regsl,regss,regst,pw,sig,sog,opns,opnsl
  global as string wpfx,wth,asg,asgs,wg,lbw,ipath,lpath,pexn,libr,ary,sps,dvl,mess
  global as string qeax,qecx,qedx,qebx,qesp,qebp,qesi,qedi,peax,pecx,pesp,pedi,ledi
  global as string pusheax,popeax,spw1,spw2
  global as string oxypath, hostdll,dats,lnkc,lnkd,defbuf,sgl,lnmks,asgp


'----------------
sub GlobalClear()
'================
  '
  dim as sys a
  ert=0 : ers=""
  cpa=0
  parx=0
  brc=0
  asce=1
  lclv=0
  wth=""
  wi=0
  ths=0 : mel=0
  prec=0
  phr=0
  ipe=0
  nsl=0
  fq=0
  dv=0
  asi=0
  cnd=0
  adra=0
  lbw=""
  pef=0
  nst=0
  pdr=0
  o2h=1
  bref=o2h 'default byref
  tmnt=0
  libe=1 : dlb=1
  expf=0
  rsrf=0
  enu=0
  enuc=0
  nrs=0
  funi=0
  libr=""
  extn=0
  cas=0
  casf=0
  cnst=0
  cbri=0
  uniq=0
  cpuw=4
  ispr=0
  typk=0
  datc=0
  dati=0
  dats=""
  lnkc=""
  lnkd=""
  defbuf=""
  stkb=0
  vaf=0
  pakd=0
  ccx=0
  '
  for a=1 to 30 : wva(a)="" : next 'CLEAR DECLARATION BUFFERS
  '
end sub



