




'--------------------------------------------
function HexLink(byref s as string) as string
'============================================
'
' a      ascii byte
' b      general purpose
' c      general purpose
' i      source string position
' j      code position
' k      general purpose
' l      length of source
' m      general purpose
' n      general purpose
' s      source  string
' t      code string
' u      general purpose
' v      general purpose
' w      general purpose
' nb()   starting position of current block
' xi()   attributes of foward reference
' xn()   label names
' bkd()  nesting depth of label
' bkp()  position of label
' bkw()  label name
' bke    label list boundary
' neb    current nesting depth
' nef    expose flag
' wd     word
' ke     keyword

' ert    global error type
' ers    global error message string
'
'BUFFERS
'
#define sizli 16383
static as sys nb(127),xi(511,3),bkd(sizli),bkp(sizli)
static as string xn(sizli),bkw(sizli)
'
dim    as sys neb, nef, xib, bke, lnki, lnkj, lnkk, bss
dim    as sys a,b,c,i,k,m,n,u,v,w,j=1,l=len(s)
dim    as any ptr pt
dim    as string wd,ke,lnkn

i=1

ert=0
lnki=0


'OUTPUT BUFFER

dim as string t=string(l-i+200,chr(0)),tb=""

'open "t.txt" for output as 3 : print #3,s : close 3 'DIAGNOSTIC

'================
'MAIN READER LOOP
'================

do ' main loop
    '
    do ' skip space for next word 
        if (i>l)or(asc(s,i)>32) then exit do
        i+=1
    loop
    if i>l then exit do
    '
    a=len(t): if j>a-4096 then t+=string(16384,chr(0))
    '
    '---------------
    'INTERPRET CASES
    '===============
    ' 
    do ' case interpret word
        a=ascl(s,i)
        '
        '------------
        'HOST SYMBOLS
        '============
        '
        '# variable address
        '------------------
        '
        if a=35 then
          m=i
          do
            i+=1
            if i>l then exit do
            a=asc(s,i): if a<48 then exit do
          loop
          wd=mid(s,m,i-m): m=0
          if len(wd) then m=GetVarPtr(wd)
          if m=0 then ers="Can't find #symbol: "+wd:ert=5: goto exitf
          mk4(t,j,m) : j+=4 ' patch in var addr
          exit do
        end if
        '
        '------------------
        'SKIP LINE COMMENTS
        '==================
        '
        if isc(a) then ' ' line comment
          do ' advance to end of line
            i+=1:a=asc(s,i)
            if a=9 then a=32 ' ignore tabs
            if (i>l)or(a<=13) then exit do
          loop
          exit do ' next word on next line
        end if
        '
        '-----------------------------
        'IGNORED SYMBOLS / PUNCTUATION
        '=============================
        '
        if a=44 then exit do ' skip comma
        if a=sr1 then exit do ' skip separator (colon / semicolon)
        '
        '--------------
        'QUOTED STRINGS
        '==============
        '
        'WIDE STRING CONVERSION
        '
        if a=&h77 then ' w"  w`
          b=ascl(s,i+1)
          if isq(b) then
            c=i+1 : wd=tword(s,c)
            m=len(t) : if j+4096+lenw*2>m then t+=string(16384+lenw*2,chr(0)) 'buffering
            i+=2
            do
              if i>l then exit do
              a=asc(s,i)
              if a=b then i+=1 : exit do
              mid(t,j)=chr(a)+chr(0) : j+=2
              i+=1
            loop
            exit do 'cases
          end if
        end if
        '
        'ASCII STRING
        '
        if isq(a) then ' quote types
          m=i+1
          do
            i+=1
            if i>l then exit do
            if asc(s,i)=a then exit do
          loop
          mid(t,j)=mid(s,m,i-m): j+=i-m: i+=1
          exit do ' cases
        end if
        '
        '---------------------
        'NOP ALIGNMENT PADDING
        '=====================
        '
        ' ! align to mod m by filling with nops
        '
        if a=33 then
          m=wval("&h"+mid(s,i+1,8)) 'HEXADECIMAL
          v=(j-1) and (m-1)
          v=m-v
          if v<m then
            t= left(t,j-1) + string(v,chr(&h90)) + mid(t,j)
            j+=v
          end if
          exit do
        end if
        '
        '-----------------------------------------------
        '$ MAKE BLOCK OF NULLS $$ ALIGNED UP TO 16 BYTES
        '===============================================
        '
        if a=36 then ' $ reserve space 
          m=0
          if asc(s,i+1)=36 then m=16 : i+=1 ' $$ ALIGN  UP TO 16
          v=wval("&h"+mid(s,i+1,9)) 'VALUE ASSUMED HEXADECIMAL
          t= left(t,j-1) + string(v+m,chr(0)) + mid(t,j) ' with m rounding margin
          j+=v
          if m then
            v=(j-1) and (m-1) ' HEX MODULUS
            v=m-v
            if v<m then j+=v
          end if
          exit do
        end if
        '
        '------------------------------------
        '/ SET ADDRESS OR /+ ALIGNMENT OFFSET
        '====================================
        '
        if a=47 then ' / set offset
          i+=1
          a=asc(s,i) : if a=43 then i+=1
          v=wval("&h"+mid(s,i,8)) 'VALUE ASSUMED HEXADECIMAL
          if a=43 then v=((j-1) \ v) * v + v 'round up with v even when already aligned
          if j>v+1 then ert=22 : ers="Location already occupied "+hex(v)+" p"+hex(j):goto exitf
          m=len(t)
          if m-4096<=v then t+=string(v+16384-m,chr(0)) 'EXTRA BUFFER SPACE
          j=v+1
          exit do
        end if
        '
        '--------------------
        'BEGINING OF NEW NEST
        '====================
        '
        if a=lbr then neb+=1:nb(neb)=j:i+=1:exit do '(
        if a=rbr then ')
          b=bke
          do
            b-=1 : if b<0 then exit do
            if bkd(b)<neb then bke=b+1 : exit do
          loop
        end if
        '
        '------------------------
        'END-OF-NEST OR DOT LABEL
        '========================
        '
        if (a=rbr)or(a=46) then ') . fwd refs only
          ke=""
          '
          'LABELS
          '------
          '
          if a=46 then 
            i+=1
'------
            ke=wword(s,i) : i-=1
            if ascw=&h62 then
              if ke="bssdata" then bss=j 'offset of bss (uninitialised data section)
            end if
            v=ascl(s,swd)*256 : a=ascl(s,swd+1):i-=1
            if a<48 then a=32
            v+=a ' 2 significant letters
            bkw(bke)=ke : bkp(bke)=j : bkd(bke)=neb-nef : bke+=1 :  ' record dot label
            a=v : nef=0
          end if
          '
          '--------------------
          'RESOLVE FORWARD REFS
          '====================
          '
          if xib>0 then
            v=xib-1
            '
            '-------------------
            'SCAN FWD REFS TABLE
            '===================
            '
            do
              if v<0 then exit do
              '
              '
              if (xi(v,1)=a)and(xi(v,2)>=neb)and(xn(v)=ke) then
                '
                'FWD REF RECORD IDENTIFIED
                '-------------------------
                '
                m=xi(v,0) 'LOCATION TO PATCH
                '
                do
                  '
                  'CHECK LONG / QUAD ADDRESSES
                  '--------------------
                  '
                  w=xi(v,3) 'LINK MODE
                  '
                  if m<0 then
                    '
                    '
                    'LONG LINKAGE
                    '
                    if w=&h61 then
                      '
                      'A'
                      '
                      mk4(t,-m,j-1) : exit do 'ABSOLUTE (OFFSET FROM 0) 32 BITS
                      '
                    elseif w=&h71 then
                      '
                      'Q'
                      '
                      mk8(t,-m,j-1) : exit do 'ABSOLUTE (OFFSET FROM 0) 64 BITS
                    else
                      '
                      'L F
                      '
                      mk4(t,-m,j+m-4) : exit do 'RELATIVE ADDRESS
                    end if
                  end if
                  '
                  'OTHERWISE SHORT LINKAGE
                  '-----------------------
                  '
                  n=(j-m-1)
                  '
                  if (n<0)or(n>127) then
                    ers=ke+" Jump out of range (-128..+127) "+str(n)
                    ert=2 : goto exitf
                  end if
                  mid(t,m)=chr(n)
                  exit do
                loop 'END OF CASES
                '
                'CLEAR RECORD ON RESOLVED LINKS
                '
                xi(v,1)=0 : xi(v,2)=0 : xn(v)="" 
              end if
              v-=1
            loop 'END OF FWD REFS LINKs
            '
            '-------------------------
            'CONSOLIDATE FWD REFS LIST
            '=========================
            '
            v=0 : m=0
            do
              m+=1
              if xi(v,1)<>0 then
                '
                'transfer reference to a lower nesting level
                '
                if a=rbr then
                  if xi(v,2)>=neb then xi(v,2)=neb-1
                end if
                v+=1 : continue do 'PRESERVE
              end if
              if m>=xib then exit do 'END OF LIST
              if xi(m,1)=0 then continue do 'M EMPTY
              xi(v,0)=xi(m,0) : xi(v,1)=xi(m,1) : xi(v,2)=xi(m,2) : xi(v,3)=xi(m,3)
              xn(v)=xn(m)
              if a=rbr then
                if xi(v,2)>=neb then xi(v,2)=neb-1
              end if
              xi(m,0)=0 : xi(m,1)=0 : xi(m,2)=0 : xi(m,3)=0 : xn(m)="" ' clear m
              v+=1
            loop
            xib=v
          end if
          '
          '--------------------------
          'CHECK FOR CLOSE OF NESTING
          '==========================
          '
          if a=rbr then
            neb-=1 ' )
            if neb<0 then ers="Too many right brackets":ert=4: goto exitf
            '
            '---------------------
            'CONSOLIDATE BACK LIST
            '=====================
            '
            'remove label references that were within the nest
            '
            v=0 : m=0
            do
              if m>=bke then exit do
              if bkd(m)>neb then m+=1 : continue do 'REMOVE
              if m>v then 
                bkw(v)=bkw(m) : bkp(v)=bkp(m) : bkd(v)=bkd(m)
                bkw(m)=""
              end if
              v+=1 : m+=1
            loop
            bke=v
          end if
          i+=1 : exit do
        end if
        '
        m=ascl(s,i+1)
        '
        '-------------------
        'G JUMP ADRESSES ETC
        '===================
        '
        if a=&h67 then
          '
          i+=1
          if m>32 then i+=1
'----
          ke=wword(s,i) : i-=1
          v=ascl(s,swd)*256 : a=ascl(s,swd+1)
          if a<48 then a=32
          v+=a ' 2 significant letters, initial search filter
          '
          '----------------
          'G INTERPRETATION
          '================
          '
          b=bke
          '
          'LINKAGE MODES
          '-------------
          '
          if m=&h66 then
            b=0 : m=&h6c ' F LONG FWD REF ONLY
          elseif m=&h73 then
            b=0 : m=&h00 ' S SHORT FWD REF ONLY
          elseif m=&h63 then
            ape(lnkc,lnki,"    ") : mk4(lnkc,lnki-3,j)  'CODE SIDE DATA LINK ADDRESS
            ape(lnkn,lnkk,"    ") : mk4(lnkn,lnkk-3,wval("&h"+ke))  'CODE SIDE DATA LINK NUMBER
            mid(t,j)=mkl(0) : j+=4
            goto nexw
          elseif m=&h64 then
            ape(lnkd,lnkj,"    ") : mk4(lnkd,lnkj-3,j)  'DATA SIDE DATA LINK LIST
            goto nexw
          end if
          '
          '
          'SEARCH BACKWARDS FOR LABEL
          '--------------------------
          '
          do
            b-=1:if b<0 then exit do
            'if (ke=bkw(b))and(bkd(b)<=neb) then
            if ke=bkw(b) then
              '
              n=bkp(b)-j 'ADDRESS DIFFERENCE
              '
              'LONG / QUAD ADDRESSES
              '
              if m=&h67 then
                if cpuw=8 then m=&h71 else m=&h61 'G' system 64 bit or 32 bit
              end if
              '
              if m=&h61 then
                mk4(t,j,n+j-1) : j+=4 : goto nexw ' A LONG OFFSET FROM 0 (32 BIT)
              elseif m=&h71 then
                mk8(t,j,n+j-1) : j+=8 : goto nexw ' A QUAD OFFSET FROM 0 (64 BIT)
              elseif m=&h6c then
                mk4(t,j,n-4) : j+=4 : goto nexw   ' L LONG RELATIVE
              end if
              '
              n-=1
              '
              'CHECK JUMP RANGE
              '----------------
              '
              if (n<-128)or(n>127) then
                ers=ke+" jump out of range (-128..+127) "+str(n)
                ert=2: goto exitf ' short jump out of range
              end if
              '
              'SHORT JUMP
              '----------
              '
              mid(t,j)=chr(n and 255) : j+=1:goto nexw
            end if
          loop
          '
          'NOT FOUND
          '
          '------------------
          'LOG AS FORWARD REF
          '==================
          '
          if m=&h67 then
            if cpuw=8 then m=&h71 else m=&h61 'system 64 bit or 32 bit
          end if
          '
          xn(xib)=ke
          'xi(xib,0)     'POSITION CODE (NEGATIVE INDICATES LONG LINK)
          xi(xib,1)=v   '2 LETTER ENCODING
          xi(xib,2)=neb 'NESTING LEVEL
          xi(xib,3)=m   'LINKAGE MODE CODE
          a=0
          if (m=&h6c)or(m=&h61)or(m=&h71) then
            xi(xib,0)=-j : xib+=1 : j+=4 'RESERVE SPACE
            if m=&h71 then j+=4 'RESERVE EXTRA SPACE FOR QUAD
            exit do' g
          end if
          '
          xi(xib,0)=j : xib+=1 : j+=1 : exit do' g  'OTHERWISE SHORT
          '
        end if 'G INSTRUCTION
        '
        '-----------
        'X EXIT NEST
        '===========
        '
        'LOG AS FWD REFERENCE
        '
        if a=&h78 then
          xn(xib)="":n=neb
          if (m>48)and(m<58) then n=neb+49-m: m=&h6c
          if n<0 then n=0
          if m=&h6c then i+=1: xi(xib,0)=-j:xi(xib,1)=rbr:xi(xib,2)=n:xib+=1:j+=4: exit do' xl x2 x3 exit
          xi(xib,0)=j:xi(xib,1)=rbr:xi(xib,2)=n:xib+=1:j+=1: exit do' x exit
        end if
        '
        '-------------
        'R REPEAT NEST
        '=============
        '
        if a=&h72 then 
          if m=&h6c then i+=1:v=nb(neb)-j-4: mk4(t,j,v) : j+=4:exit do ' r repeat
          v=nb(neb)-j-1
          if v<-128 then
            ers="'Repeat' out of range (-128..+127) "+str$(v)
            ert=3: goto exitf ' short loop out of range
          end if
          mid(t,j)=chr(v and &hff):j+=1:exit do
        end if
        '
        '
        '======
        'VALUES
        '======
        '
        '
        'otherwise assume a decimal octal or hex code
        '
        '---------------------
        'H HEXADECIMAL NUMBERS
        '=====================
        '
        if a=&h68 then
          i+=2
          pt=strptr(t)
          '
          asm
            mov ecx,[s]
            mov ecx,[ecx]
            add ecx,[i]
            dec ecx 'offset
            rhgap:
              mov al,[ecx]
              inc ecx
              cmp al,0
              jz xhgap
              cmp al,32
              jle rhgap
            xhgap:
            dec ecx
            dec ecx 'align for hexaval
            mov esi,[pt]
            add esi,[j]
            dec esi 'offset
            call hexaval
            mov cl,[m]
            '
            cmp cl,&h77 'w' word
            jnz hexl4
            mov [esi],ax
            mov eax,2
            jmp xhexli
            '
            hexl4:
            cmp cl,&h6c 'l' long
            jnz hexl8
            chexl4:
            mov [esi],eax
            mov eax,4
            jmp xhexli
            '
            hexl8:
            cmp cl,&h71 'q' quad
            jnz hexlg
            chexl8:
            mov [esi],eax
            mov [esi+4],edx
            mov eax,8
            jmp xhexli
            '
            hexlg:
            cmp cl,&h67 'g' system (4 or 8 byte)
            jnz xhexli
            cmp dword ptr cpuw,8
            jnz chexl4
            jmp chexl8
            '
            mov eax,0 'no interpretation
            '
            xhexli:
            '
            add [j],eax
          end asm
          '
          skipspace(s,i)
          exit do
        end if
        '
        '-----------------
        'N DECIMAL NUMBERS
        '=================
        '
        if a=&h6e then
          i+=2
          pt=strptr(t)
          '
          asm
            mov ecx,[s]
            mov ecx,[ecx]
            add ecx,[i]
            dec ecx 'offset
            mov esi,[pt]
            add esi,[j]
            dec esi 'offset
            rngap:
              mov al,[ecx]
              inc ecx
              cmp al,0
              jz xngap
              cmp al,32
              jle rngap
            xngap:
            dec ecx
            '
            push ecx
            call ascii_to_float
            mov al,[m]
            '
            cmp al,&h77 'w' word
            jnz numl4
            fistp word ptr [esi]
            mov eax,2
            jmp xnumli
            '
            numl4:
            cmp al,&h6c 'l' long
            jnz numl8
            cnuml4:
            fistp dword ptr [esi]
            mov eax,4
            jmp xnumli
            '
            numl8:
            cmp al,&h71 'q' quad
            jnz numlg
            cnuml8:
            fistp qword ptr [esi]
            mov eax,8
            jmp xnumli
            '
            numlg:
            cmp al,&h67 'g' system (4 or 8 byte)
            jnz numl1
            cmp dword ptr cpuw,8           
            jnz cnuml4
            jmp cnuml8
            '
            numl1:
            cmp al,&h62 'b' byte
            jnz numfl4
            fistp word ptr [esi]
            mov eax,1
            jmp xnumli
            '
            numfl4:
            cmp al,&h73 's' single
            jnz numfl8
            fstp dword ptr [esi]
            mov eax,4
            jmp xnumli
            '
            numfl8:
            cmp al,&h64 'd' double
            jnz xnumli
            fstp qword ptr [esi]
            mov eax,8
            jmp xnumli
            '
            xnumli:
            '
            add [j],eax
            '
          end asm
          '
          skipspace(s,i)
          exit do
        end if
        '
        'S
        '
        if a=&h73 then
          '
          'SX
          '
          if m=&h78 then
            if neb then nef=1
            exit do
          end if
          '
          'SY
          '
        end if
        '
        '----------
        'OCTAL BYTE
        '==========
        '
        if i+2<l then 'octal byte
          if asc(s,i+2)>47 then mid(t,j)=chr(wval("&o"+mid(s,i,3))): j+=1: exit do
        end if
        '
        '----------------
        'DEFAULT HEX BYTE
        '================
        '
        pt=strptr(t)
        asm
          mov ecx,[s]
          mov ecx,[ecx]
          add ecx,[i]
          dec ecx 'offset
          dec ecx 'align for hexaval
          mov esi,[pt]
          add esi,[j]
          dec esi 'offset
          call hexaval
          mov [esi],al
          inc dword ptr [j]
        end asm
        '
        exit do ' always drop out
        '
    loop 'END CASES
    '
    '=====
    nexw:
    '=====
    '
    do ' find delimiting char before next word 
      if (i>l)or(asc(s,i)<=32) then exit do
      i+=1
    loop
    '
    if xib>sizli then ert=15 : goto exitf ' ref limit
  loop
  '
  '=====
  exitf:
  '=====
  '
  '
  'LINK INITIALISED DATA TO CODE
  '=============================
  '
  'first get offset of uninitialised data (bss)
  'this value is stored in ebx therefore
  'data is accessed as a negative offset from this position
  '
  '
  '-----------------------------------------------
  'HEADER | CODE | DATA BSS | EDATA | IDATA | RSRC
  '-----------------------------------------------
  '
  '
  n=lnki-1
  for m=1 to n step 4
    a=midval(lnkc,m)
    b=midval(lnkn,m)*4-3
    c=midval(lnkd,b)-bss
    mk4(t,a,c+4) '1st 4 bytes gives length
  next
  '
  'CHECK FOR ERRORS
  '===============
  '
  if j<2 then ers="No code to generate":ert=10
  if (ert=0)and(xib>0) then
    ers="Linker found unidentified names:"
    v=xib:a=0
    '
    do
      v-=1:if v<0 then exit do
      a=xi(v,1)
      ers+=cr+xn(v)+":"+chr(9)+"level "+str(xi(v,2))
    loop
    ers+=cr
    ert=1000000+xi(xib-1,1) 'unresolved refs
  end if
  '
  if ert>0 then function=chr(&hc3) : exit function
  function=tb+left(t,j-1)
  '
end function


